Subject: [babel] Fw: Babel YANG

From: tom petch <[email-masked]>
Date: Fri, 10 Sep 2021 16:46:40 +0000

TRY again (the glories of WEBMAIL last thing on a Friday afternoon)

________________________________________
From: tom petch <[email-masked]>
Sent: 10 September 2021 17:37
To: [email-masked]

I see a version of the Babel YANG I-D has appeared and that the AD is looking at it.  Looking through it I was struck by the references to a uint16 leaf having a NULL value.  This is not something I am familiar with so I asked on the NETMOD list and they are not familiar with it either.  They suggested that it should be fixed

Some languages have the concept, YANG does not.

I used to have an MUA that allowed me to attach another e-mail but I cannot see how to do that with modern software so you may have to look at NETMOD list to see the thread.

Re: [netmod] NULL value for uint16

The RFC editor is not going to fix this, for them it is beyond
editorial. For me it makes sense to report this, let alone to spread
the word that there is no NULL in YANG land. Sure, things like this
should be catched earlier but things are as they are and a late fix
is still better than publishing questionable examples.

/js

On Fri, Sep 10, 2021 at 04:06:14PM +0000, tom petch wrote:
> From: Jürgen Schönwälder <[email-masked]>
> Sent: 10 September 2021 13:14
> 
> I guess the description should be worded as
> 
>   "This leaf does not exist if ..."
> 
> instead of talking about NULL, a concept that does not exist in the
> YANG language and the protocols.
> 
> One subtle point with the "does not exist" approach is that a client
> cannot reliably distinguish between 'a leaf does not exist' and
> 'access to a leaf was denied by an authorization policy'. In practice,
> though, most authorization policies tend to be rather coarse grained.
> 
> <tp>
> 
> Juergen, Lada
> 
> Thank you for the prompt responses.  This is an I-D that has been to the IESG although the announcement has yet to appear, which makes me coy about saying which it is:-)  My inclination is to let sleeping dogs lie and see what comes out of the RFC Editor (probably the same as went in: but if you think it significant enough, I would flag it to the WG Chair:-(
> 
> Tom Petch
> 
> /js
> 
> On Fri, Sep 10, 2021 at 11:56:22AM +0000, tom petch wrote:
> > Does NULL have any meaning for a leaf of type uint16?
> >
> > Looking at a leaf of type uint16 the description says that
> > 'This metric will be NULL (no value) ..'
> >
> > Some languages differentiate  a 'never been set' state from e.g set to zero or some other value but for me, YANG does not have that concept.  Rather the leaf does not exist which  will be reflected by the protocol accessing the leaf.
> >
> > I see no NULL at least in this context in RFC7950.
> >
> > Tom petch
> > _______________________________________________
> > netmod mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/netmod
> 
> --
> Juergen Schoenwaelder           Jacobs University Bremen gGmbH
> Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
> Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>

Tom Petch